CON

  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000
  
  MAXSPEED = 5000
    
  WHEEL_RED_0 = 11 'to brown to red to IN1 front L298N
  WHEEL_BLACK_0 = 12 'to red to orange IN2 front L298N
  WHEEL_RED_1 = 13 'to orange to yellow to IN3 front L298N 
  WHEEL_BLACK_1 = 14 'to yellow to blue to IN4 front L298N 
  WHEEL_RED_2 = 23 'to violet to yellow to IN3 back L298N 
  WHEEL_BLACK_2 = 24 'to grey to blue to IN4 back L298N
  WHEEL_RED_3 = 15 'to green to red to IN1 back L298N
  WHEEL_BLACK_3 = 22 'blue to orange to IN2 back L298N
  FIRST_ENCODER_0 = 4 '12
  FIRST_ENCODER_1 = 6 '10
  FIRST_ENCODER_2 = 0 '8
  FIRST_ENCODER_3 = 2 '6
  WHEEL_ENABLE_0 = 27 'to green to ENA front L298N
  WHEEL_ENABLE_1 = 9 'to yellow to ENB front L298N
  WHEEL_ENABLE_2 = 8 'to green to ENB back L298N
  WHEEL_ENABLE_3 = 10 'to blue to ENA back L298N
VAR

  long enablePin[4], motorPinRed[4], motorPinBlack[4]
   
OBJ

  'Pst : "Parallax Serial Terminal"
  Pwm : "fourMotorsOneCog121216c"
  
PUB Setup

  'Pst.Start(115200)
  {Pwm.Start(16, 17, 18, 19, {
             } 0, 1, 2, 3, {
             } 20, 21, 22, 23)    }
  enablePin[0] := WHEEL_ENABLE_0
  motorPinRed[0] := WHEEL_RED_0
  motorPinBlack[0] := WHEEL_BLACK_0
  enablePin[1] := WHEEL_ENABLE_1
  motorPinRed[1] := WHEEL_BLACK_1 'WHEEL_RED_1 '
  motorPinBlack[1] := WHEEL_RED_1 'WHEEL_BLACK_1 '
  enablePin[2] := WHEEL_ENABLE_2
  motorPinRed[2] := WHEEL_RED_2
  motorPinBlack[2] := WHEEL_BLACK_2
  enablePin[3] := WHEEL_ENABLE_3
  motorPinRed[3] := WHEEL_BLACK_3 'WHEEL_RED_3 '
  motorPinBlack[3] := WHEEL_RED_3 'WHEEL_BLACK_3 '

  Pwm.Start(motorPinRed[0], motorPinRed[1], motorPinRed[2], motorPinRed[3], {
  } motorPinBlack[0], motorPinBlack[1], motorPinBlack[2], motorPinBlack[3], {
  } enablePin[0], enablePin[1], enablePin[2], enablePin[3])
           
  MainLoop

PUB MainLoop | index

  repeat
    repeat index from 0 to 10
      {Pst.char(13)
      repeat result from 0 to 3
        Pst.str(string(13, "Speed["))
        Pst.dec(result)
        Pst.str(string("] = ")) 
        Pst.dec(speed[(index * 4) + result])
      Pst.CharIn    }
      Pwm.Update(speed[index * 4], speed[(index * 4) + 1], {
      } speed[(index * 4) + 2], speed[(index * 4) + 3])  
      
DAT

speed         long 1000, 359, 1000, 359
              long 1000, 359, 1000, 359
              long 300, 0, 0, 0
              long 0, 0, 0, 0
              long 0, 300, 0, 0
              long 0, 0, 400, 0
              long 0, 0, 0, 400
              long 400, 400, 400, 400
              long 200, 202, 204, 206
              long 500, 500, 500, 500
              long -300, -200, 200, 300        